Differences between revisions 16 and 24 (spanning 8 versions)
Revision 16 as of 2009-12-29 16:53:20
Size: 1223
Editor: MatthiasPopp
Comment:
Revision 24 as of 2016-06-16 06:35:08
Size: 1823
Editor: 176
Comment: Remove some inconsistant useless quotes
Deletions are marked like this. Additions are marked like this.
Line 3: Line 3:
(If you were looking for option processing, see [[BashFAQ/035]].)

The following functions are frequently asked for in #bash, so we hope you find them useful.
(If you were looking for option processing, see [[BashFAQ/035]].)  The following functions are frequently asked for in #bash, so we hope you find them useful.
Line 10: Line 8:
# Usage: warn "message" # Usage: warn "format" ["arguments"...]
Line 13: Line 11:
  printf '%s\n' "$@" >&2   local fmt=$1
  shift
  printf "script_name: $fmt\n" "$@" >&2
Line 25: Line 25:
# Usage: some_command || die "message" # Usage: some_command || die "message" ["arguments"...]
Line 28: Line 28:
  local st="$?"   local st=$?
Line 36: Line 36:
# Usage: if blah; then die "message" status_code; fi # Usage: if blah; then die status_code "message" ["arguments"...]; fi
Line 39: Line 39:
  local st="$2"
  warn "$1"
  local st=$1
  shift

  warn "$@"
Line 48: Line 49:
# Usage: some_command || die "message" [status code] # Usage: some_command || die [status code] "message" ["arguments"...]
Line 51: Line 52:
  local st="$?"
  case "$2" in
   
*[^0-9]*) :;;
    *) st="$2";;
  esac
  warn "$1"
  local st=$?
  if [[ $1 != *[^0-9]* ]]; then
    st=$1
    shift
  fi

  warn "$@"
Line 61: Line 62:

{{{
##
# warn: Print a message to stderr.
# Usage: warn "message"
#
warn() {
  printf '%s\n' "$@" >&2
}

##
# die (optional status version): Print a message to
# stderr and exit with either the given status or
# that of the most recent command.
# Usage: some_command || die "message" [status code]
# some_command && die "message" [status code]

die() {
  local st=$?
  case $2 in
    *[^0-9]*|'') :;;
    *) st=$2;;
  esac
  warn "$1"
  exit "$st"
}
}}}

Common utility functions (warn, die)

(If you were looking for option processing, see BashFAQ/035.) The following functions are frequently asked for in #bash, so we hope you find them useful.

##
# warn: Print a message to stderr.
# Usage: warn "format" ["arguments"...]
#
warn() {
  local fmt=$1
  shift
  printf "script_name: $fmt\n" "$@" >&2
}

###
### The following three "die" functions
### depend on the above "warn" function.
###

##
# die (simple version): Print a message to stderr
# and exit with the exit status of the most recent
# command.
# Usage: some_command || die "message" ["arguments"...]
#
die () {
  local st=$?
  warn "$@"
  exit "$st"
}

##
# die (explicit status version): Print a message to
# stderr and exit with the exit status given.
# Usage: if blah; then die status_code "message" ["arguments"...]; fi
#
die() {
  local st=$1
  shift
  warn "$@"
  exit "$st"
}

##
# die (optional status version): Print a message to
# stderr and exit with either the given status or
# that of the most recent command.
# Usage: some_command || die [status code] "message" ["arguments"...]
#
die() {
  local st=$?
  if [[ $1 != *[^0-9]* ]]; then
    st=$1
    shift
  fi
  warn "$@"
  exit "$st"
}

##
# warn: Print a message to stderr.
# Usage: warn "message"
#
warn() {
  printf '%s\n' "$@" >&2
}

##
# die (optional status version): Print a message to
# stderr and exit with either the given status or
# that of the most recent command.
# Usage: some_command || die "message" [status code]
#        some_command && die "message" [status code]

die() {
  local st=$?
  case $2 in
    *[^0-9]*|'') :;;
    *) st=$2;;
  esac
  warn "$1"
  exit "$st"
} 


CategoryShell

BashFAQ/101 (last edited 2020-02-04 18:35:41 by GreyCat)